#ifndef KEYS_H_INCLUDED
#define	KEYS_H_INCLUDED
/* --------------------------------------------------------------------------------- */
#include <htc.h>
#include "led.h"
/* --------------------------------------------------------------------------------- */
#define S1					RA5		
#define S2					RA2
#define	S4					RA4
#define KEY_MASQ			(1<<2|1<<4|1<<5) //RA2 RA4 RA5
#define	KEY_COUNTER			30		//anti osc stick
#define	KEY_COUNTER_LONG	300		//time of long pressed 
/* --------------------------------------------------------------------------------- */
//flag number:
#define	PL_FLAG				6		//key pressed long event
#define	R_FLAG				5		//key released event
#define	P_FLAG				4		//key pressed event
#define	DLT_FLAG			3		//key down long state last (temp)
#define	DT_FLAG				2		//key down last (temp)
#define	DL_FLAG				1		//key down long time
#define	D_FLAG				0		//key down 

//state machines definition:
#define	STATE_S4_IDX			0
#define	STATE_S1_IDX			1
#define	STATE_S2_IDX			2
#define	STATE_S1S4_IDX			3
#define	KEY_STATES				4	//number of key-event sources

//events definition
const u8 keyEvents[8] = {
				//	DT	DL	D
	0b00000000,	//	0	0	0
	0b00010001,	//	0	0	1	pressed
	0b00000010,	//	0	1	0
	0b00000011,	//	0	1	1
	0b00100100,	//	1	0	0	released
	0b00000101,	//	1	0	1
	0b00000110,	//	1	1	0
	0b01000111	//	1	1	1	pressed long
};
/* --------------------------------------------------------------------------------- */
struct {
	unsigned	fpl	:	1;
	unsigned	fr	:	1;
	unsigned	frl	:	1;
	unsigned	fp	:	1;
	unsigned	dlt	:	1;
	unsigned	dt	:	1;
	unsigned	dl	:	1;
	unsigned	d	:	1;
} keysState[KEY_STATES];
/* --------------------------------------------------------------------------------- */
u16 keyS1counter;
u16 keyS2counter;
u16 keyS4counter;
unsigned char key_counter;
/* --------------------------------------------------------------------------------- */
void initKeys();
void handleKeys();
/* --------------------------------------------------------------------------------- */
#endif