#include <stdio.h>

//DEFINITION OF LED MATRIX
//----------------------------------------------------------------------------------
//				PORTB	PORTC	TRISB			TRISC
//-------------------- SECTION 0 ---------------------------------------------------
//order by diode nr
#define D1	{	0,		1<<4,	0,				1<<4|1<<5}	//1		D2 	S0	RC4->RC5
#define D2	{	0,		1<<5,	0,				1<<5|1<<3}	//2		D4 	S0	RC5->RC3
#define D4	{	0,		1<<5,	0,				1<<4|1<<5}	//4		D1	S0	RC5->RC4
#define D5	{	0,		1<<3,	0,				1<<3|1<<5}	//5		D3	S0	RC3->RC5
#define D9	{	0,		1<<4,	0,				1<<4|1<<3} 	//9		D5	S0	RC4->RC3
#define D10	{	0,		1<<3,	0,				1<<3|1<<6}	//10	D8	S0	RC3->RC6
#define D11	{	0,		1<<4,	0,				1<<4|1<<6}	//11	D10	S0	RC4->RC6
#define D12	{	0,		1<<6,	0,				1<<6|1<<4}	//12	D11	S0	RC6->RC4
#define D16	{	0,		1<<3,	0,				1<<3|1<<4}	//16	D6	S0	RC3->RC4
#define D17	{	0,		1<<6,	0,				1<<6|1<<3}	//17	D9	S0	RC6->RC3
#define D24	{	0,		1<<5,	0,				1<<5|1<<6}	//24	D7	S0	RC5->RC6

#define S0_0	1	
#define S0_1	2	
#define S0_2	4	
#define S0_3	5	
#define S0_4	9	
#define S0_5	10	
#define S0_6	11	
#define S0_7	12	
#define S0_8	16	
#define S0_9	17	
#define S0_10	24	

//-------------------- SECTION 1 ---------------------------------------------------
//order by diode no
#define D18	{	0,		1<<7,	1<<6,			1<<7}		//18	D17	S1	RC7->RB6
#define D19	{	1<<6,	0,		1<<6,			1<<7}		//19	D16	S1	RB6->RC7
#define D21	{	0,		1<<7,	1<<5,			1<<7}		//21	D20	S1	RC7->RB5
#define D22	{	1<<6,	0,		1<<6|1<<7,		0}			//22	D19	S1	RB6->RB7
#define D23	{	1<<7,	0,		1<<7|1<<6,		0}			//23	D18	S1	RB7->RB6
#define D25	{	1<<7,	0,		1<<7,			1<<7}		//25	D13	S1	RB7->RC7
#define D26	{	0,		1<<7,	1<<7,			1<<7}		//26	D12	S1	RC7->RB7
#define D27	{	1<<5,	0,		1<<5|1<<6,		0}			//27	D22	S1	RB5->RB6
#define D28	{	1<<6,	0,		1<<6|1<<5,		0}			//28	D21	S1	RB6->RB5
#define D29	{	1<<5,	0,		1<<5|1<<7,		0}			//29	D24	S1	RB5->RB7
#define D32	{	1<<7,	0,		1<<7|1<<5,		0}			//32	D23	S1	RB7->RB5

#define S1_0	18
#define S1_1	19
#define S1_2	21	
#define S1_3	22	
#define S1_4	23	
#define S1_5	25	
#define S1_6	26	
#define S1_7	27	
#define S1_8	28	
#define S1_9	29	
#define S1_10	32	

//-------------------- SECTION 2 ---------------------------------------------------
#define D0	{	0,		1<<1,	0,				1<<1|1<<0}	//0		D32 S2	RC1->RC0	
#define D3	{	0,		1<<0,	0,				1<<0|1<<1}	//3		D33	S2	RC0->RC1
#define D6	{	0,		1<<0,	0,				1<<0|1<<2}	//6		D35	S2	RC0->RC2
#define D7	{	0,		1<<1,	0,				1<<1|1<<2} 	//7		D30	S2	RC1->RC2
#define D8	{	0,		1<<2,	0,				1<<2|1<<1}	//8		D29	S2	RC2->RC1
#define D13	{	0,		1<<1,	1<<4,			1<<1}		//13	D27	S2	RC1->RB4
#define D14	{	1<<4,	0,		1<<4,			1<<0}		//14	D31	S2	RB4->RC0
#define D15	{	0,		1<<2,	0,				1<<2|1<<0}	//15	D34	S2	RC2->RC0
#define D20	{	1<<4,	0,		1<<4,			1<<1}		//20	D28	S2	RB4->RC1
#define D30	{	0,		1<<2,	1<<4,			1<<2}		//30	D26	S2	RC2->RB4
#define D31	{	1<<4,	0,		1<<4,			1<<2}		//31	D25	S2	RB4->RC2

#define S2_0	0	
#define S2_1	3	
#define S2_2	6	
#define S2_3	7	
#define S2_4	8	
#define S2_5	13	
#define S2_6	14	
#define S2_7	15	
#define S2_8	20	
#define S2_9	30	
#define S2_10	31	
//----------------------------------------------------------------------------------
const unsigned char sec[3][11][4] = {	
{S0_0,S0_1,S0_2,S0_3,S0_4,S0_5,S0_6,S0_7,S0_8,S0_9,S0_10},	//S0
{S1_0,S1_1,S1_2,S1_3,S1_4,S1_5,S1_6,S1_7,S1_8,S1_9,S1_10},	//S1
{S2_0,S2_1,S2_2,S2_3,S2_4,S2_5,S2_6,S2_7,S2_8,S2_9,S2_10}	//S2
};

int main() {
    int i,j,k,l,m;
	return 0;
	
    printf("const unsigned char sec[11][4] = {\n", j, k);
    for(i = 0; i < 11 - 1; i++) {
		printf("\t{\t(\t");
        for(j = 0; j < 3 - 1; j++) {
            for(k = 0; k < 4 - 1; k++) {
                printf("\tleds[S%d_%d][%d]\t|", j, i, k);
            }
			printf("\tleds[S%d_%d][%d]\t)\t,\t(\t", j, i, k);
        }
		for(k = 0; k < 4 - 1; k++) {
			printf("\tleds[S%d_%d][%d]\t|", j, i, k);
		}
		printf("\tleds[S%d_%d][%d]\t)\t},\n", j, i, k);
    }
	printf("\t{\t(\t");
	for(j = 0; j < 3 - 1; j++) {
		for(k = 0; k < 4 - 1; k++) {
			printf("\tleds[S%d_%d][%d]\t|", j, i, k);
		}
		printf("\tleds[S%d_%d][%d]\t)\t,\t(\t", j, i, k);
	}
	for(k = 0; k < 4 - 1; k++) {
		printf("\tleds[S%d_%d][%d]\t|", j, i, k);
	}
	printf("\tleds[S%d_%d][%d]\t)\t}\n}\n", j, i, k);

    return 0;
}
